package com.sun.org.apache.bcel.internal.classfile;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.DataInput;

public final class ConstantDouble extends Constant implements ConstantObject
{
    private double bytes;
    
    public ConstantDouble(double bytes) {
        super((byte)6);
        this.bytes = bytes;
    }
    
    public ConstantDouble(ConstantDouble c) {
        this(c.getBytes());
    }
    
    ConstantDouble(DataInput file) throws IOException {
        this(file.readDouble());
    }
    
    @Override
    public void accept(Visitor v) {
        v.visitConstantDouble(this);
    }
    
    @Override
    public final void dump(DataOutputStream file) throws IOException {
        file.writeByte((int)super.getTag());
        file.writeDouble(this.bytes);
    }
    
    public final double getBytes() {
        return this.bytes;
    }
    
    public final void setBytes(double bytes) {
        this.bytes = bytes;
    }
    
    @Override
    public final String toString() {
        return super.toString() + "(bytes = " + this.bytes + ")";
    }
    
    @Override
    public Object getConstantValue(ConstantPool cp) {
        return new Double(this.bytes);
    }
}
